program Project1;

uses
  SDL,
  SDL_Image,
  sysutils,
  SDL_TTF,
  SDL_Mixer;

{$R *.res}

Type
 TGameState = (GSGame,GSQuit,GSGameOver,GsIntro);

Const
 fps = 30;

Var
 nexttime : cardinal;
 gameState : TgameState = GsIntro;
 Screen,Background,Player,enemy : PSDL_Surface;
 enemyStates : array[0..2,0..2] of boolean;
 PlayerStates : array[0..2] of boolean;
 Hitposition,liveslost : integer;
 Ticksound,crashsound : PMIX_Chunk;
 SoundEnabled : boolean = true;
 font : PTTF_Font;
 score : longint = 0;
Function GetAppPath : String;
begin
 Result := ExtractFilePath(paramstr(0));
end;

Function Waitforframe : cardinal;
var
now : cardinal;
begin
 now := SDL_Getticks;
 if now >= nexttime then
 begin
  result :=0;
  NextTime := now + round(1000/fps);
 end
 else
  Result := NextTime - now;
end;

procedure DrawGame;
var
 x,y : integer;
 dstrect : TSDL_Rect;
begin
 for x := 0 to 2 do
  for y := 0 to 2 do
  begin
   if enemyStates[x,y] then
   begin
    dstrect.x := 90 + (x * 54);
    dstrect.y := 48 + (y * 47);
    Dstrect.w := enemy.w;
    dstrect.h := enemy.h;
    SDL_BlitSurface(Enemy,nil,screen,@dstrect);
   end;
  end;
 for x := 0 to 2 do
  if playerstates[x] then
  begin
   dstrect.x := 90 + (x * 54);
   dstrect.y := 180;
   Dstrect.w := player.w;
   dstrect.h := player.h;
   SDL_BlitSurface(player,nil,screen,@dstrect);
  end;
end;

Procedure moveEnemy;
var
 x,y : integer;
begin
 for x := 0 to 2 do
  for y := 2 downto 1 do
  begin
   enemystates[x,y] := enemystates[x,y-1];
  end;
 for x := 0 to 2 do enemystates[x,0] := false;
 for x := 0 to 1 do
  enemystates[random(3),0] := true;
end;

Procedure MoveLeft;
var
 x : integer;
begin
 for x := 0 to 1 do
 begin
  if playerstates[x + 1] then
  begin
   playerstates[x] := true;
   Playerstates[x+1] := false;
  end;
 end;
end;

procedure moveright;
var
 x : integer;
begin
 for x := 2 downto 1 do
 begin
  if playerstates[x - 1] then
  begin
   playerstates[x] := true;
   Playerstates[x-1] := false;
  end;
 end;
end;

Function IsCollided:boolean;
var
 x : integer;
 temp : boolean;
begin
 temp := false;
 for x := 0 to 2 do
  if (playerstates[x] and enemystates[x,2]) then
  begin
   temp := true;
   hitposition := x;
  end;
 result := temp;
end;

procedure hitflash;
begin
 playerstates[hitposition] := not playerstates[hitposition];
 enemystates[hitposition,2] := not enemystates[hitposition,2];
end;

procedure initialisestates;
var
 x,y : integer;
begin
 for x := 0 to 2 do
  for y := 0 to 2 do
   enemystates[x,y] := false;
 for x := 0 to 2 do
  playerstates[x] := false;
 playerstates[1] := true;
end;

procedure game;
var
 event : TSDL_Event;
 teller,flashesdelay,flashes,x,delay : integer;
 canmove,crashsoundplayed : boolean;
 Text : PSDL_Surface;
 fg,bg : TSDL_Color;
 dstrect : TSDL_rect;
 str : string;
begin
 teller := 25;
 flashesdelay := 14;
 flashes := 0;
 canmove := true;
 score := 0;
 fg.r := 0;
 fg.g := 0;
 fg.b := 0;
 bg.r := 172;
 bg.g := 172;
 bg.b := 172;
 delay := 60;
 liveslost := 0;
 crashsoundplayed := false;
 initialisestates;
 While GameState = GSGame do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   If (event.type_ = SDL_QUITEV) or
      ((event.type_ = SDL_KEYDOWN) and
       (event.key.keysym.sym = SDLK_ESCAPE)) then GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_LEFT) then if canmove then moveleft;
   if (event.type_ = SDL_KEYDOWN) and
      (event.key.keysym.sym = SDLK_RIGHT) then if canmove then moveRight;
  end;
  SDL_Blitsurface(background,nil,screen,nil);
  text := TTF_rendertext_shaded(font,pchar(inttostr(score)),fg,bg);
  dstrect.x := 230-text.w;
  dstrect.y := 30;
  dstrect.w := text.w;
  dstrect.h := text.h;
  SDL_Blitsurface(text,nil,screen,@dstrect);
  SDL_FreeSurface(text);
  if liveslost >= 1 then
  begin
   str := '';
   for x := 1 to liveslost do str := str + 'X';
   text := TTF_Rendertext_shaded(font,pchar(str),fg,bg);
   dstrect.x := 90;
   dstrect.y := 30;
   dstrect.w := text.w;
   dstrect.h := text.h;
   SDL_Blitsurface(text,nil,screen,@dstrect);
   SDL_FreeSurface(text);
  end;
  inc(teller);
  if teller >= delay then
  begin
   if (not iscollided) and  canmove then
   begin
    teller := 0;
    for x := 0 to 2 do
     if enemystates[x,2] then
     begin
      inc(score,10);
      if (score mod 100 = 0) and (delay > 18) then
      begin
       dec(delay);
      end;
     end;
    moveenemy;
    if soundenabled then mix_playchannel(-1,ticksound,0);
   end
   else
   begin
    if not crashsoundplayed then if soundenabled then
     mix_playchannel(-1,crashsound,0);
    canmove := false;
    inc(flashesdelay);
    if flashesdelay = 15 then
    begin
     inc(flashes);
     hitflash;
     flashesdelay := 0;
     if (flashes)=6 then
     begin
      flashes := 0;
      canmove := true;
      teller := 0;
      enemystates[hitposition,2] := false;
      inc(liveslost);
      flashesdelay := 14;
      if liveslost = 3 then gamestate := GSGameover
     end;
    end;
   end;
  end;
  drawgame;
  SDL_FLip(screen);
  SDL_Delay(WaitForFrame);
 end;
end;

procedure gameover;
var
 event : TSDL_Event;
 x : integer;
 Text : PSDL_Surface;
 fg,bg : TSDL_Color;
 dstrect : TSDL_rect;
 str : string;
begin
 fg.r := 0;
 fg.g := 0;
 fg.b := 0;
 bg.r := 172;
 bg.g := 172;
 bg.b := 172;
 While GameState = GSGameover do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   If (event.type_ = SDL_QUITEV) or
      ((event.type_ = SDL_KEYDOWN) and
       (event.key.keysym.sym = SDLK_ESCAPE)) then GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      ((event.key.keysym.sym = SDLK_SPACE) or
       (event.key.keysym.sym = SDLK_RETURN)) then gamestate := GSGame;
  end;
  SDL_Blitsurface(background,nil,screen,nil);
  text := TTF_rendertext_shaded(font,pchar(inttostr(score)),fg,bg);
  dstrect.x := 230-text.w;
  dstrect.y := 30;
  dstrect.w := text.w;
  dstrect.h := text.h;
  SDL_Blitsurface(text,nil,screen,@dstrect);
  SDL_FreeSurface(text);
  if liveslost >= 1 then
  begin
   str := '';
   for x := 1 to liveslost do str := str + 'X';
   text := TTF_Rendertext_shaded(font,pchar(str),fg,bg);
   dstrect.x := 90;
   dstrect.y := 30;
   dstrect.w := text.w;
   dstrect.h := text.h;
   SDL_Blitsurface(text,nil,screen,@dstrect);
   SDL_FreeSurface(text);
  end;
  drawgame;
  SDL_FLip(screen);
  SDL_Delay(WaitForFrame);
 end;
end;

Procedure flashintro;
var
 x,y : integer;
begin
 for x := 0 to 2 do
  for y := 0 to 2 do
   enemystates[x,y] := not enemystates[x,y];
 for x := 0 to 2 do
  playerstates[x] := not playerstates[x];
end;

procedure intro;
var
 event : TSDL_Event;
 x,flashesdelay : integer;
 Text : PSDL_Surface;
 fg,bg : TSDL_Color;
 dstrect : TSDL_rect;
 scorestr,str : string;
begin
 fg.r := 0;
 fg.g := 0;
 fg.b := 0;
 bg.r := 172;
 bg.g := 172;
 bg.b := 172;
 Liveslost := 0;
 flashesdelay := 0;
 Scorestr := '';                      
 While GameState = GSintro do
 begin
  While SDL_Pollevent(@event) > 0 do
  begin
   If (event.type_ = SDL_QUITEV) or
      ((event.type_ = SDL_KEYDOWN) and
       (event.key.keysym.sym = SDLK_ESCAPE)) then GameState := GSQuit;
   if (event.type_ = SDL_KEYDOWN) and
      ((event.key.keysym.sym = SDLK_SPACE) or
       (event.key.keysym.sym = SDLK_RETURN)) then gamestate := GSGame;
  end;
  SDL_Blitsurface(background,nil,screen,nil);
  inc(flashesdelay);
  if flashesdelay = 25 then
  begin
   flashesdelay := 0;
   flashintro;
   if playerstates[0] then
   begin
    scorestr := '888888';
    liveslost := 3;
   end
   else
   begin
    scorestr := '';
    liveslost := 0;
   end;
  end;
  if length(scorestr) > 0 then
  begin
   text := TTF_rendertext_shaded(font,pchar(scorestr),fg,bg);
   dstrect.x := 230-text.w;
   dstrect.y := 30;
   dstrect.w := text.w;
   dstrect.h := text.h;
   SDL_Blitsurface(text,nil,screen,@dstrect);
   SDL_FreeSurface(text);
  end;
  if liveslost >= 1 then
  begin
   str := '';
   for x := 1 to liveslost do str := str + 'X';
   text := TTF_Rendertext_shaded(font,pchar(str),fg,bg);
   dstrect.x := 90;
   dstrect.y := 30;
   dstrect.w := text.w;
   dstrect.h := text.h;
   SDL_Blitsurface(text,nil,screen,@dstrect);
   SDL_FreeSurface(text);
  end;
  drawgame;
  SDL_FLip(screen);
  SDL_Delay(WaitForFrame);
 end;
end;

begin
 If SDL_INIT(SDL_INIT_VIDEO or SDL_INIT_AUDIO) = 0 then
 begin
  Screen := SDL_SetVideomode(320,240,16,SDL_LOGPAL or SDL_SWSURFACE);
  if screen <> nil then
  begin
   if Mix_openaudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,MIX_DEFAULT_CHANNELS,1024)< 0 then
   begin
    SoundEnabled := false;
   end;
   TTF_init;
   randomize;
   Font := TTF_Openfont(pchar(getapppath + 'font.ttf'),14);
   Ticksound := MIX_loadwav(pchar(getapppath + 'tick.wav'));
   crashsound := MIX_Loadwav(pchar(getapppath + 'crash.wav'));
   Background := IMG_Load(pchar(getapppath + 'Background.png'));
   Player := IMG_Load(pchar(Getapppath + 'player.png'));
   Enemy := IMG_Load(pchar(Getapppath + 'enemy.png'));
   SDL_WM_Setcaption('Formula 1','');
   SDL_ShowCursor(0);
   while gamestate <> Gsquit do
   begin
    Case GameState of
     Gsintro : intro;
     GSGame : Game;
     GsGameOver : GameOver;
    end;
   end;
   ttf_closefont(font);
   TTF_Quit;
   Mix_freechunk(crashsound);
   Mix_freechunk(ticksound);
   Mix_CloseAudio;
   SDL_FreeSurface(Background);
   SDL_FreeSurface(Player);
   SDL_FreeSurface(enemy);
   SDL_FreeSurface(screen);
   SDL_Quit;
  end;
 end;
end.
